libstdc++: __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare > Class Template Reference

libstdc++

__gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare > Class Template Reference

`#include <losertree.h>`

Inheritance diagram for __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >:
[legend]

## Public Member Functions
| _LoserTreeUnguardedBase (unsigned int __k, const _Tp &__sentinel, _Compare __comp=std::less< _Tp >())
int | __get_min_source ()
void | __insert_start (const _Tp &__key, int __source, bool)

## Protected Attributes
_Compare | _M_comp
unsigned int | _M_ik
unsigned int | _M_k
_Loser * | _M_losers
unsigned int | _M_offset

## Detailed Description

template<typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >

Base class for unguarded _LoserTree implementation.

The whole element is copied into the tree structure.

No guarding is done, therefore not a single input sequence must run empty. Unused __sequence heads are marked with a sentinel which is > all elements that are to be merged.

This is a very fast variant.

Definition at line 574 of file losertree.h.

## Constructor & Destructor Documentation

## ◆ _LoserTreeUnguardedBase()

template<typename _Tp, typename _Compare>

__gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_LoserTreeUnguardedBase | ( | unsigned int | __k,
|  | const _Tp & | __sentinel,
|  | _Compare | __comp = std::less<_Tp>() )
| inline

Definition at line 588 of file losertree.h.

## ◆ ~_LoserTreeUnguardedBase()

template<typename _Tp, typename _Compare>

__gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::~_LoserTreeUnguardedBase | ( |  | ) |
| inline

Definition at line 613 of file losertree.h.

## Member Function Documentation

## ◆ __get_min_source()

template<typename _Tp, typename _Compare>

int __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::__get_min_source | ( |  | ) |
| inline

Definition at line 621 of file losertree.h.

## ◆ __insert_start()

template<typename _Tp, typename _Compare>

void __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::__insert_start | ( | const _Tp & | __key,
|  | int | __source,
|  | bool | )
| inline

Definition at line 631 of file losertree.h.

## Member Data Documentation

## ◆ _M_comp

template<typename _Tp, typename _Compare>

_Compare __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_M_comp
| protected

Definition at line 585 of file losertree.h.

## ◆ _M_ik

template<typename _Tp, typename _Compare>

unsigned int __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_M_ik
| protected

Definition at line 583 of file losertree.h.

## ◆ _M_k

template<typename _Tp, typename _Compare>

unsigned int __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_M_k
| protected

Definition at line 583 of file losertree.h.

## ◆ _M_losers

template<typename _Tp, typename _Compare>

_Loser* __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_M_losers
| protected

Definition at line 584 of file losertree.h.

## ◆ _M_offset

template<typename _Tp, typename _Compare>

unsigned int __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >::_M_offset
| protected

Definition at line 583 of file losertree.h.

The documentation for this class was generated from the following file:

- losertree.h